package com.itbaizhan.mapper;

import com.itbaizhan.pojo.PageQuery;
import com.itbaizhan.pojo.User;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

//操作User实体类与数据库的交互
//SQL语句需要写在映射当中
public interface UserMapper2 {
    List<User> findByCondition(User user);
    void updateUser(User user);
    /**
     * 根据用户名查询用户：
     *  参数长度小于5：模糊查询
     *  参数长度5~10：精确查询
     *  否则：返回id为1的用户
     */
    List<User> findByUsername(String username);
    void deleteBatch(int[] ids);
    void insertBatch(List<User> user);
    List<User> findUser(@Param("queryMap") Map<String,Object> map);

}
