import com.itbaizhan.mapper.TeacherMapper;
import com.itbaizhan.mapper.UserMapper;
import com.itbaizhan.pojo.PageQuery;
import com.itbaizhan.pojo.Teacher;
import com.itbaizhan.pojo.User;
import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import java.io.InputStream;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class TestTeacherMapper {
    InputStream is=null;
    SqlSession session=null;
    TeacherMapper teacherMapper=null;
    @Before
    public void before()throws Exception{
        //1.获取核心配置文件
        is =
                Resources.getResourceAsStream("SqlMapConfig.xml");
        //2.创建SqlSessionfactoryBuilder对象
        SqlSessionFactoryBuilder builder =
                new SqlSessionFactoryBuilder();
        //3.SqlSessionfactoryBuilder对象获取//SqlSessionfactory
        SqlSessionFactory factory = builder.build(is);
        //4.SqlSessionfactory对象获取SqlSession对象
        session = factory.openSession();
        //5.SqlSession对象获取代理
        teacherMapper = session.getMapper(TeacherMapper.class);

    }
    @After
    public void after() throws Exception{
        session.close();
        is.close();
    }
    @Test
    public void testFindAll() throws Exception{
        List<Teacher> all= teacherMapper.findAll();
        all.forEach(System.out::println );

    }
    @Test
    public void testFindById() throws Exception{
        Teacher teacher = teacherMapper.findById(2);
        System.out.println(teacher);
    }

    @Test
    public void testFindById2() throws Exception{
        List<Teacher> all = teacherMapper.findById2(2);
        all.forEach(System.out::println);
    }


}
