import com.itbaizhan.mapper.UserMapper;
import com.itbaizhan.pojo.PageQuery;
import com.itbaizhan.pojo.User;
import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import javax.annotation.Resource;
import java.io.InputStream;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class TestUserMapper2 {
    InputStream is=null;
    SqlSession session=null;
    UserMapper userMapper=null;
    @Before
    public void before()throws Exception{
        //1.获取核心配置文件
        is =
                Resources.getResourceAsStream("SqlMapConfig.xml");
        //2.创建SqlSessionfactoryBuilder对象
        SqlSessionFactoryBuilder builder =
                new SqlSessionFactoryBuilder();
        //3.SqlSessionfactoryBuilder对象获取//SqlSessionfactory
        SqlSessionFactory factory = builder.build(is);
        //4.SqlSessionfactory对象获取SqlSession对象
        session = factory.openSession();
        //5.SqlSession对象获取代理
        userMapper = session.getMapper(UserMapper.class);

    }
    @After
    public void after() throws Exception{
        session.close();
        is.close();
    }
    @Test
    public void testUpdate() throws Exception{
        User user=new User(7,"程序媛","女","深圳");
        userMapper.update(user);
        session.commit();

    }
    @Test
    public void testDelete(){
        userMapper.delete(7);
        session.commit();
    }
    @Test
    public void testFindById(){
        User user = userMapper.findById(5);
        System.out.println(user);

    }
    @Test
    public void testFindByUsernameLike(){
        List<User> users = userMapper.FindByUsernameLike("%尚学堂%");
        users.forEach(System.out::println);

    }

    @Test
    public void testFindPage(){
        List<User> users = userMapper.FindPage(0, 3);
        users.forEach(System.out::println);
    }

    @Test
    public void testFindPage1(){
        List<User> users = userMapper.FindPage(3, 1);
        users.forEach(System.out::println);
    }
    @Test
    public void testFindPage2(){
        PageQuery pageQuery = new PageQuery(3,1);
        List<User> users = userMapper.FindPage2(pageQuery);
        users.forEach(System.out::println);
    }
    @Test
    public void testFindPage3(){
        Map<String,Object> params = new HashMap();
        params.put("startIndex",0);
        params.put("pageSize",4);
        List<User> users = userMapper.FindPage3(params);
        users.forEach(System.out::println);
    }

    @Test
    public void testFindCount(){
        int count = userMapper.findCount();
        System.out.println(count);
    }

    @Test
    public void testAdd2(){
        User user=new User("程序猿","男","北京");
        System.out.println(user);
        userMapper.add2(user);
        session.commit();
        System.out.println(user);


    }


}
