import com.itbaizhan.mapper.UserMapper2;
import com.itbaizhan.pojo.PageQuery;
import com.itbaizhan.pojo.User;
import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import javax.annotation.Resource;
import java.io.InputStream;
import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class TestUserMapper3 {
    InputStream is=null;
    SqlSession session=null;
    UserMapper2 userMapper2=null;
    @Before
    public void before()throws Exception{
        //1.获取核心配置文件
        is =
                Resources.getResourceAsStream("SqlMapConfig.xml");
        //2.创建SqlSessionfactoryBuilder对象
        SqlSessionFactoryBuilder builder =
                new SqlSessionFactoryBuilder();
        //3.SqlSessionfactoryBuilder对象获取//SqlSessionfactory
        SqlSessionFactory factory = builder.build(is);
        //4.SqlSessionfactory对象获取SqlSession对象
        session = factory.openSession();
        //5.SqlSession对象获取代理
        userMapper2 = session.getMapper(UserMapper2.class);

    }
    @After
    public void after() throws Exception{
        session.close();
        is.close();
    }
    @Test
    public void testFindByCondition() throws Exception{
        User user = new User();
        List<User> users = userMapper2.findByCondition(user);
        user.setUsername("%尚学堂%");
        List<User> users2 = userMapper2.findByCondition(user);
        users2.forEach(System.out::println);


    }
    @Test
    public void testUpdateUser(){
        User user = new User();
        user.setId(10);
        user.setUsername("我是程序媛");
        user.setSex("女");
        userMapper2.updateUser(user);
        session.commit();
    }
    @Test
    public void testFindByUsername(){
        List<User> users = userMapper2.findByUsername("北京尚学堂对对对对对");
        users.forEach(System.out::println);
    }
    @Test
    public void testDeleteBatch(){
        int[] ids={13,14,15};
        userMapper2.deleteBatch(ids);
        session.commit();
    }
    @Test
    public void testInsertBatch(){
        User user1 = new User("程序员1","女","深圳");
        User user2 = new User("程序员2","男","南京");
        List<User> users = new ArrayList();
        users.add(user1);
        users.add(user2);
        userMapper2.insertBatch(users);
        session.commit();
    }
    @Test
    public void testFindUser(){
        Map<String,Object> findmap= new HashMap();
        findmap.put("sex","女");
        findmap.put("address","北京");
        List<User> users = userMapper2.findUser(findmap);
        users.forEach(System.out::println);


    }

}
