import com.itbaizhan.mapper.ClassMapper;
import com.itbaizhan.mapper.StudentMapper;
import com.itbaizhan.mapper.TeacherMapper;
import com.itbaizhan.mapper2.ClassMapper2;
import com.itbaizhan.pojo.Classes;
import com.itbaizhan.pojo.Student;
import com.itbaizhan.pojo.Teacher;
import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import java.io.InputStream;
import java.util.List;

public class TestManyTAbleQuery {
    InputStream is=null;
    SqlSession session=null;
    @Before
    public void before()throws Exception{
        //1.获取核心配置文件
        is =
                Resources.getResourceAsStream("SqlMapConfig.xml");
        //2.创建SqlSessionfactoryBuilder对象
        SqlSessionFactoryBuilder builder =
                new SqlSessionFactoryBuilder();
        //3.SqlSessionfactoryBuilder对象获取//SqlSessionfactory
        SqlSessionFactory factory = builder.build(is);
        //4.SqlSessionfactory对象获取SqlSession对象
        session = factory.openSession();


    }
    @After
    public void after() throws Exception{
        session.close();
        is.close();
    }

    @Test
    public void testFindAllStudent(){
        StudentMapper studentMapper =
                session.getMapper(StudentMapper.class);
        List<Student> all = studentMapper.findAll();
        all.forEach(System.out::println);
    }

    @Test
    public void testFindAllClasses(){
        ClassMapper classesMapper=
                session.getMapper(ClassMapper.class);
        List<Classes> all= classesMapper.findClasses();
        all.forEach(System.out::println);
    }
    @Test
    public void testFindAllTeacher(){
        TeacherMapper teacherMapper =
                session.getMapper(TeacherMapper.class);
        List<Teacher> all= teacherMapper.findAll();
        all.forEach(System.out::println);
    }
    @Test
    public void testFindAllClasses2(){
        ClassMapper2 classesMapper2=
                session.getMapper(ClassMapper2.class);
        List<Classes> all= classesMapper2.findAll();
        all.forEach(System.out::println);
    }
}
